<template>
    <div class="root">
        <form onsubmit="return false">
            <div>
                <label for="email">Email</label>
                <input type="email" id="email" v-model="email"/>
            </div>
            <div>
                <label for="password">Password</label>
                <input type="password" id="password" v-model="password"/>
            </div>
            <div>
                <button @click="signInWithEmail">Login</button>
                <button @click="signUpNewUser">Signup</button>
                <button @click="updateUserInfo('John', 'Doe')">Update User Info John</button>
                <button @click="updateUserInfo('Elen', 'Doe')">Update User Info Elen</button>
            </div>
        </form>
        <div v-if="responseData">
            {{responseData}}
        </div>

        <div v-if="errorValue">
            {{errorValue}}
        </div>
        {{userInfo}}
    </div>
</template>
<script setup lang="ts">
import {onBeforeMount, ref} from 'vue'
import { createClient } from '@supabase/supabase-js'
const supabase = createClient('https://pcjsipbqzizxtsfzwuco.supabase.co', 'eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJpc3MiOiJzdXBhYmFzZSIsInJlZiI6InBjanNpcGJxeml6eHRzZnp3dWNvIiwicm9sZSI6ImFub24iLCJpYXQiOjE2OTk3MTM2NTEsImV4cCI6MjAxNTI4OTY1MX0.-2Jl1mUDJxaaOStjV5o1DFZPbwtmkCNtzL3xe0hnnw0')

const responseData = ref()
const errorValue = ref()

const email = ref()
const password = ref()

const userInfo = ref({
    first_name: '',
    last_name: ''
})

async function signUpNewUser() {
    const { data, error } = await supabase.auth.signUp({
        email: email.value,
        password: password.value,
        options: {}
    })
    responseData.value = data
    errorValue.value = error
}

async function signInWithEmail() {
    const { data, error } = await supabase.auth.signInWithPassword({
        email: email.value,
        password: password.value,
        options: {
        }
    })
    responseData.value = data
    errorValue.value = error
    await validateToken()
}

onBeforeMount(async () => {
    await validateToken()
    await getUserInfo()
})

async function validateToken() {
    const {data, error} = await supabase.auth.getSession()
    if (data?.session) {
        const result = await fetch('/api/validate-token', {
            headers: {
                'Content-Type': 'application/json',
                'Authorization': 'Bearer ' + data.session.access_token
            },
        })
        console.log(result)
    } else {
        console.log('no session')
    }
}

async function getUserInfo() {
    const {data, error} = await supabase.auth.getSession()
    if (data?.session) {
        const result = await fetch('/api/user-info', {
            headers: {
                'Content-Type': 'application/json',
                'Authorization': 'Bearer ' + data.session.access_token
            },
        })
        const responseData = await result.json()
        userInfo.value = {...responseData.user_info.data[0]}
    } else {
        console.log('no session')
    }
}

async function updateUserInfo(firstName: string, lastName: string) {
    const {data, error} = await supabase.auth.getSession()
    if (data?.session) {
        const result = await fetch('/api/user-info', {
            method: 'POST',
            headers: {
                'Content-Type': 'application/json',
                'Authorization': 'Bearer ' + data.session.access_token
            },
            body: JSON.stringify({
                first_name: firstName,
                last_name: lastName
            })
        })
        console.log(result)
    } else {
        console.log('no session')
    }
}
</script>

<style scoped>
.root {
    max-width: 800px;
    margin: 100px auto;
}
form > div {
    margin-bottom: 16px;
    display: flex;
    justify-content: space-between;
}

form > div > * {
    width: 50%;
}
</style>